controllers/AutoresController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Autores;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;

/**
 * AutoresController implements the CRUD actions for Autores model.
 */
class AutoresController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index','logout'],
                'rules' => [
                    [
                        'actions' => ['index','logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Autores models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Autores::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Autores model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }
    
    public function actionViewfe($id)
    {
        return $this->render('view_fe', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Autores model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Autores();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Autores model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Autores model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Autores model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Autores the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Autores::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Noticias;
use app\models\Autores;
use app\models\Fotografos;
use app\models\Etiquetas;
use app\models\Categorizan;
use app\models\NoticiasForm;
use app\models\FormRegister;
use app\models\Usuarios;
use yii\helpers\Html;
use yii\helpers\Url;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionLogin()
    {
        //si quiero conocer el nombre de usuario
        //var_dump(Yii::$app->user->identity);
        //exit;
        //
        //
        // en caso de no estar logueado nos colocamos en la pagina de inicio
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }
        
        

        $model = new LoginForm();
        // en caso de intentar realizar un logueo
        
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            // si es correcto volvemos a la pagina anterior
            return $this->goBack();
        }
        
        // en caso de que el logueo no sea correcto no entramos
        return $this->render('login', [
            'model' => $model,
        ]);
    }


    public function actionLogout()
    {
        // nos salimos de la sesion
        Yii::$app->user->logout();

        return $this->goHome();
    }
    
    private function randKey($str='', $long=0)
    {
        $key = null;
        $str = str_split($str);
        $start = 0;
        $limit = count($str)-1;
        for($x=0; $x<$long; $x++)
        {
            $key .= $str[rand($start, $limit)];
        }
        return $key;
    }
    
    public function actionUrl(){
        echo Html::a("texto","@web/index.php/site/confirm?id=1&authKey=2");
        echo Html::a('Confirmar registro', "@web/index.php/site/confirm?id=1", ['class' => 'profile-link']);
        echo Html::a('Confirmar registro',"http://localhost" . Url::to(["site/confirm"]));
    }


    public function actionRegister()
    {
         //Creamos la instancia con el model de validación
         $model = new FormRegister;

         //Mostrará un mensaje en la vista cuando el usuario se haya registrado
         $msg = null;

         //Validación mediante ajax
       //  if ($model->load(Yii::$app->request->post()) && Yii::$app->request->isAjax)
       //        {
       //            Yii::$app->response->format = Response::FORMAT_JSON;
       //            return ActiveForm::validate($model);
       //        }

         //Validación cuando el formulario es enviado vía post
         //Esto sucede cuando la validación ajax se ha llevado a cabo correctamente
         //También previene por si el usuario tiene desactivado javascript y la
         //validación mediante ajax no puede ser llevada a cabo
         if ($model->load(Yii::$app->request->post())) //se cogen todos los datos que vienen del formulario
         {

          if($model->validate())//comprueba las rules del modelo (FormRegister)
          {
           //Preparamos la consulta para guardar el usuario
           $table = new Usuarios;
           $table->usuario = $model->usuario;
           $table->email = $model->email;
           //Encriptamos el password
           $table->password = crypt($model->password, Yii::$app->params["salt"]);
           //Creamos una cookie para autenticar al usuario cuando decida recordar la sesión, esta misma
           //clave será utilizada para activar el usuario
           $table->authKey = $this->randKey("abcdef0123456789", 200);
           //Creamos un token de acceso único para el usuario
           $table->accessToken = $this->randKey("abcdef0123456789", 200);

           //Si el registro es guardado correctamente
           if ($table->insert())//save si existe lo va a actualizar
           {
            //Nueva consulta para obtener el id del usuario
            //Para confirmar al usuario se requiere su id y su authKey
            $user = $table->find()->where(["email" => $model->email])->one();
            $id = urlencode($user->id);//formatear ese dato para que sea admitido por la URL (como los espacios en blanco)
            $authKey = urlencode($user->authKey);

            $subject = "Confirmar registro";
           
            $body = "<h1>Haga click en el siguiente enlace para finalizar tu registro</h1>";
            //$body .= "<a href='http://127.0.0.1/.../index.php?r=site/confirm&id=".$id."&authKey=".$authKey."'>Confirmar</a>";
            $body .= Html::a('Confirmar registro', "http://localhost/" . Yii::getAlias("@web") . "/index.php/site/confirm?id=$id&authKey=$authKey", ['class' => 'profile-link']); 
            //cambiar por HTML::a... hasta r= 
            //los parametros sean $id y $authKey

           // $body .= Html::a("Confirmar",[site/confirmar,"id"=>$id,"authKey"=>$authKey]);

            //Enviamos el correo
            Yii::$app->mailer->compose()
            ->setTo($user->email)
            ->setFrom([Yii::$app->params["adminEmail"] => Yii::$app->params["title"]])
            ->setSubject($subject)
            ->setHtmlBody($body)
            ->send();

            $model->usuario = null;
            $model->email = null;
            $model->password = null;
            $model->password_repeat = null;

            $msg = "Enhorabuena, ahora sólo falta que confirmes tu registro en tu cuenta de correo";
           }
           else
           {
            $msg = "Ha ocurrido un error al llevar a cabo tu registro";
           }

          }
          else
          {
           $model->getErrors();
          }
         }
         return $this->render("register", ["model" => $model, "msg" => $msg]);
        }
        
    public function actionConfirm()
    {
       $table = new Usuarios;
       if (Yii::$app->request->get())
       {

           //Obtenemos el valor de los parámetros get
           $id = $_GET["id"];
           $authKey = $_GET["authKey"];

           if ((int) $id)
           {
               //Realizamos la consulta para obtener el registro
               $model = $table
               ->find()
               ->where("id=:id", [":id" => $id])
               ->andWhere("authKey=:authKey", [":authKey" => $authKey]);

               //Si el registro existe
               if ($model->count() == 1)
               {
                   $activar = Usuarios::findOne($id);
                   $activar->activate = 1;
                   if ($activar->update())
                   {
                       echo "Enhorabuena registro llevado a cabo correctamente, redireccionando ...";
                       echo "<meta http-equiv='refresh' content='8; ".Url::toRoute("site/login")."'>";
                   }
                   else
                   {
                       echo "Ha ocurrido un error al realizar el registro, redireccionando ...";
                       echo "<meta http-equiv='refresh' content='8; ".Url::toRoute("site/login")."'>";
                   }
                }
               else //Si no existe redireccionamos a login
               {
                   return $this->redirect(["site/login"]);
               }
           }
           else //Si id no es un número entero redireccionamos a login
           {
               return $this->redirect(["site/login"]);
           }
       }
    }
    
    /**
     * Displays frontend page for noticias.
     *
     * 
     */
    public function actionIndexnoticias()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Noticias::find(),
        ]);

        return $this->render('vista1', [
            "dataProvider" => $dataProvider,
            "campos"=>['texto'],
            "titulo"=>"Noticias de nuestro periódico",
          ]);
    }
    
     /**
     * Displays frontend page for autores.
     *
     * 
     */
    public function actionIndexautores()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Autores::find(),
        ]);

        return $this->render('vista2', [
            "dataProvider" => $dataProvider,
            "campos"=>['texto'],
            "titulo"=>"Autores de nuestro periódico",
          ]);
    }
    
     /**
     * Displays frontend page for fotografos.
     *
     * 
     */
    public function actionIndexfotografos()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografos::find(),
        ]);

        return $this->render('vista3', [
            "dataProvider" => $dataProvider,
            "campos"=>['texto'],
            "titulo"=>"Fotógrafos de nuestro periódico",
          ]);
    }
    
     /**
     * Displays frontend page for fotografos.
     *
     * 
     */

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar-inverse navbar-fixed-top',
        ],
    ]);
    
    if(Yii::$app->user->isGuest){
        echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-right'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Login', 'url' => ['/site/login']],
            ['label' => 'Noticias', 'url' => ['/site/indexnoticias']],
            ['label' => 'Autores', 'url' => ['/site/indexautores']],
            ['label' => 'Fotógrafos', 'url' => ['/site/indexfotografos']],
            ['label' => 'Etiquetas', 'url' => ['/site/indexetiquetas']],
            ['label' => 'Enviar Noticia', 'url' => ['/site/enviarnoticia']],
        ],
    ]);
    }else{
        echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-right'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Autores', 'url' => ['/autores/index']],//'visible'=>Yii::app()->user->identity->isAdmin],//,'visible'=>Yii::app()->user->identity->isAdmin?
            ['label' => 'Noticias', 'url' => ['/noticias/index']],
            ['label' => 'Fotógrafos', 'url' => ['/fotografos/index']],
            //['label' => 'Ilustran Fotos', 'url' => ['/ilustranfotos/index']],
            ['label' => 'Etiquetas', 'url' => ['/etiquetas/index']],
            ['label' => 'Noticias', 'url' => ['/site/indexnoticias']],
            ['label' => 'Autores', 'url' => ['/site/indexautores']],
            ['label' => 'Fotógrafos', 'url' => ['/site/indexfotografos']],
            ['label' => 'Etiquetas', 'url' => ['/site/indexetiquetas']],
            ['label' => 'Contacto', 'url' => ['/site/contact']],
                '<li>'
                . Html::beginForm(['/site/logout'], 'post')
                . Html::submitButton(
                    'Logout (' . Yii::$app->user->identity->email . ')',
                    ['class' => 'btn btn-link logout']
                )
                . Html::endForm()
                . '</li>',
        ],
    ]);
    }
    
    
    NavBar::end();
    ?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>

<footer class="footer">
    <div class="container">
        <p class="pull-left">&copy; My Company <?= date('Y') ?></p>

        <p class="pull-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>